]> git.ipfire.org Git - thirdparty/git.git/blob - t/test-lib.sh
Merge branch 'en/merge-recursive-directory-rename-fixes'
[thirdparty/git.git] / t / test-lib.sh
1 # Test framework for git. See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
26 else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
51
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55 exit 1
56 fi
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
59
60 # Disallow the use of abbreviated options in the test suite by default
61 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
62 then
63 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
65 fi
66
67 ################################################################
68 # It appears that people try to run tests without building...
69 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
70 if test $? != 1
71 then
72 if test -n "$GIT_TEST_INSTALLED"
73 then
74 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
75 else
76 echo >&2 'error: you do not seem to have built git yet.'
77 fi
78 exit 1
79 fi
80
81 # Parse options while taking care to leave $@ intact, so we will still
82 # have all the original command line options when executing the test
83 # script again for '--tee' and '--verbose-log' below.
84 store_arg_to=
85 prev_opt=
86 for opt
87 do
88 if test -n "$store_arg_to"
89 then
90 eval $store_arg_to=\$opt
91 store_arg_to=
92 prev_opt=
93 continue
94 fi
95
96 case "$opt" in
97 -d|--d|--de|--deb|--debu|--debug)
98 debug=t ;;
99 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
100 immediate=t ;;
101 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
102 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
103 -r)
104 store_arg_to=run_list
105 ;;
106 --run=*)
107 run_list=${opt#--*=} ;;
108 -h|--h|--he|--hel|--help)
109 help=t ;;
110 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
111 verbose=t ;;
112 --verbose-only=*)
113 verbose_only=${opt#--*=}
114 ;;
115 -q|--q|--qu|--qui|--quie|--quiet)
116 # Ignore --quiet under a TAP::Harness. Saying how many tests
117 # passed without the ok/not ok details is always an error.
118 test -z "$HARNESS_ACTIVE" && quiet=t ;;
119 --with-dashes)
120 with_dashes=t ;;
121 --no-bin-wrappers)
122 no_bin_wrappers=t ;;
123 --no-color)
124 color= ;;
125 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
126 valgrind=memcheck
127 tee=t
128 ;;
129 --valgrind=*)
130 valgrind=${opt#--*=}
131 tee=t
132 ;;
133 --valgrind-only=*)
134 valgrind_only=${opt#--*=}
135 tee=t
136 ;;
137 --tee)
138 tee=t ;;
139 --root=*)
140 root=${opt#--*=} ;;
141 --chain-lint)
142 GIT_TEST_CHAIN_LINT=1 ;;
143 --no-chain-lint)
144 GIT_TEST_CHAIN_LINT=0 ;;
145 -x)
146 trace=t ;;
147 -V|--verbose-log)
148 verbose_log=t
149 tee=t
150 ;;
151 --write-junit-xml)
152 write_junit_xml=t
153 ;;
154 --stress)
155 stress=t ;;
156 --stress=*)
157 echo "error: --stress does not accept an argument: '$opt'" >&2
158 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
159 exit 1
160 ;;
161 --stress-jobs=*)
162 stress=t;
163 stress=${opt#--*=}
164 case "$stress" in
165 *[!0-9]*|0*|"")
166 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
167 exit 1
168 ;;
169 *) # Good.
170 ;;
171 esac
172 ;;
173 --stress-limit=*)
174 stress=t;
175 stress_limit=${opt#--*=}
176 case "$stress_limit" in
177 *[!0-9]*|0*|"")
178 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
179 exit 1
180 ;;
181 *) # Good.
182 ;;
183 esac
184 ;;
185 *)
186 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
187 esac
188
189 prev_opt=$opt
190 done
191 if test -n "$store_arg_to"
192 then
193 echo "error: $prev_opt requires an argument" >&2
194 exit 1
195 fi
196
197 if test -n "$valgrind_only"
198 then
199 test -z "$valgrind" && valgrind=memcheck
200 test -z "$verbose" && verbose_only="$valgrind_only"
201 elif test -n "$valgrind"
202 then
203 test -z "$verbose_log" && verbose=t
204 fi
205
206 if test -n "$stress"
207 then
208 verbose=t
209 trace=t
210 immediate=t
211 fi
212
213 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
214 TEST_NAME="$(basename "$0" .sh)"
215 TEST_NUMBER="${TEST_NAME%%-*}"
216 TEST_NUMBER="${TEST_NUMBER#t}"
217 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
218 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
219 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
220 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
221 case "$TRASH_DIRECTORY" in
222 /*) ;; # absolute path is good
223 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
224 esac
225
226 # If --stress was passed, run this test repeatedly in several parallel loops.
227 if test "$GIT_TEST_STRESS_STARTED" = "done"
228 then
229 : # Don't stress test again.
230 elif test -n "$stress"
231 then
232 if test "$stress" != t
233 then
234 job_count=$stress
235 elif test -n "$GIT_TEST_STRESS_LOAD"
236 then
237 job_count="$GIT_TEST_STRESS_LOAD"
238 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
239 test -n "$job_count"
240 then
241 job_count=$((2 * $job_count))
242 else
243 job_count=8
244 fi
245
246 mkdir -p "$TEST_RESULTS_DIR"
247 stressfail="$TEST_RESULTS_BASE.stress-failed"
248 rm -f "$stressfail"
249
250 stress_exit=0
251 trap '
252 kill $job_pids 2>/dev/null
253 wait
254 stress_exit=1
255 ' TERM INT HUP
256
257 job_pids=
258 job_nr=0
259 while test $job_nr -lt "$job_count"
260 do
261 (
262 GIT_TEST_STRESS_STARTED=done
263 GIT_TEST_STRESS_JOB_NR=$job_nr
264 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
265
266 trap '
267 kill $test_pid 2>/dev/null
268 wait
269 exit 1
270 ' TERM INT
271
272 cnt=1
273 while ! test -e "$stressfail" &&
274 { test -z "$stress_limit" ||
275 test $cnt -le $stress_limit ; }
276 do
277 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
278 test_pid=$!
279
280 if wait $test_pid
281 then
282 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
283 else
284 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
285 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
286 fi
287 cnt=$(($cnt + 1))
288 done
289 ) &
290 job_pids="$job_pids $!"
291 job_nr=$(($job_nr + 1))
292 done
293
294 wait
295
296 if test -f "$stressfail"
297 then
298 stress_exit=1
299 echo "Log(s) of failed test run(s):"
300 for failed_job_nr in $(sort -n "$stressfail")
301 do
302 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
303 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
304 done
305 rm -rf "$TRASH_DIRECTORY.stress-failed"
306 # Move the last one.
307 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
308 fi
309
310 exit $stress_exit
311 fi
312
313 # if --tee was passed, write the output not only to the terminal, but
314 # additionally to the file test-results/$BASENAME.out, too.
315 if test "$GIT_TEST_TEE_STARTED" = "done"
316 then
317 : # do not redirect again
318 elif test -n "$tee"
319 then
320 mkdir -p "$TEST_RESULTS_DIR"
321
322 # Make this filename available to the sub-process in case it is using
323 # --verbose-log.
324 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
325 export GIT_TEST_TEE_OUTPUT_FILE
326
327 # Truncate before calling "tee -a" to get rid of the results
328 # from any previous runs.
329 >"$GIT_TEST_TEE_OUTPUT_FILE"
330
331 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
332 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
333 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
334 exit
335 fi
336
337 if test -n "$trace" && test -n "$test_untraceable"
338 then
339 # '-x' tracing requested, but this test script can't be reliably
340 # traced, unless it is run with a Bash version supporting
341 # BASH_XTRACEFD (introduced in Bash v4.1).
342 #
343 # Perform this version check _after_ the test script was
344 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
345 # '--verbose-log', so the right shell is checked and the
346 # warning is issued only once.
347 if test -n "$BASH_VERSION" && eval '
348 test ${BASH_VERSINFO[0]} -gt 4 || {
349 test ${BASH_VERSINFO[0]} -eq 4 &&
350 test ${BASH_VERSINFO[1]} -ge 1
351 }
352 '
353 then
354 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
355 else
356 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
357 trace=
358 fi
359 fi
360 if test -n "$trace" && test -z "$verbose_log"
361 then
362 verbose=t
363 fi
364
365 # For repeatability, reset the environment to known value.
366 # TERM is sanitized below, after saving color control sequences.
367 LANG=C
368 LC_ALL=C
369 PAGER=cat
370 TZ=UTC
371 export LANG LC_ALL PAGER TZ
372 EDITOR=:
373
374 # GIT_TEST_GETTEXT_POISON should not influence git commands executed
375 # during initialization of test-lib and the test repo. Back it up,
376 # unset and then restore after initialization is finished.
377 if test -n "$GIT_TEST_GETTEXT_POISON"
378 then
379 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
380 unset GIT_TEST_GETTEXT_POISON
381 fi
382
383 # A call to "unset" with no arguments causes at least Solaris 10
384 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
385 # deriving from the command substitution clustered with the other
386 # ones.
387 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
388 my @env = keys %ENV;
389 my $ok = join("|", qw(
390 TRACE
391 DEBUG
392 TEST
393 .*_TEST
394 PROVE
395 VALGRIND
396 UNZIP
397 PERF_
398 CURL_VERBOSE
399 TRACE_CURL
400 ));
401 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
402 print join("\n", @vars);
403 ')
404 unset XDG_CACHE_HOME
405 unset XDG_CONFIG_HOME
406 unset GITPERLLIB
407 GIT_AUTHOR_EMAIL=author@example.com
408 GIT_AUTHOR_NAME='A U Thor'
409 GIT_COMMITTER_EMAIL=committer@example.com
410 GIT_COMMITTER_NAME='C O Mitter'
411 GIT_MERGE_VERBOSITY=5
412 GIT_MERGE_AUTOEDIT=no
413 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
414 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
415 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
416 export EDITOR
417
418 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
419 GIT_TRACE_BARE=1
420 export GIT_TRACE_BARE
421
422 check_var_migration () {
423 # the warnings and hints given from this helper depends
424 # on end-user settings, which will disrupt the self-test
425 # done on the test framework itself.
426 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
427 t) return ;;
428 esac
429
430 old_name=$1 new_name=$2
431 eval "old_isset=\${${old_name}:+isset}"
432 eval "new_isset=\${${new_name}:+isset}"
433
434 case "$old_isset,$new_isset" in
435 isset,)
436 echo >&2 "warning: $old_name is now $new_name"
437 echo >&2 "hint: set $new_name too during the transition period"
438 eval "$new_name=\$$old_name"
439 ;;
440 isset,isset)
441 # do this later
442 # echo >&2 "warning: $old_name is now $new_name"
443 # echo >&2 "hint: remove $old_name"
444 ;;
445 esac
446 }
447
448 check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
449 check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
450 check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
451
452 # Use specific version of the index file format
453 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
454 then
455 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
456 export GIT_INDEX_VERSION
457 fi
458
459 # Add libc MALLOC and MALLOC_PERTURB test
460 # only if we are not executing the test with valgrind
461 if test -n "$valgrind" ||
462 test -n "$TEST_NO_MALLOC_CHECK"
463 then
464 setup_malloc_check () {
465 : nothing
466 }
467 teardown_malloc_check () {
468 : nothing
469 }
470 else
471 setup_malloc_check () {
472 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
473 export MALLOC_CHECK_ MALLOC_PERTURB_
474 }
475 teardown_malloc_check () {
476 unset MALLOC_CHECK_ MALLOC_PERTURB_
477 }
478 fi
479
480 # Protect ourselves from common misconfiguration to export
481 # CDPATH into the environment
482 unset CDPATH
483
484 unset GREP_OPTIONS
485 unset UNZIP
486
487 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
488 1|2|true)
489 GIT_TRACE=4
490 ;;
491 esac
492
493 # Convenience
494 #
495 # A regexp to match 5, 35 and 40 hexdigits
496 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
497 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
498 _x40="$_x35$_x05"
499
500 # Zero SHA-1
501 _z40=0000000000000000000000000000000000000000
502
503 OID_REGEX="$_x40"
504 ZERO_OID=$_z40
505 EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
506 EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
507
508 # Line feed
509 LF='
510 '
511
512 # Single quote
513 SQ=\'
514
515 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
516 # when case-folding filenames
517 u200c=$(printf '\342\200\214')
518
519 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
520
521 # Each test should start with something like this, after copyright notices:
522 #
523 # test_description='Description of this test...
524 # This test checks if command xyzzy does the right thing...
525 # '
526 # . ./test-lib.sh
527 test "x$TERM" != "xdumb" && (
528 test -t 1 &&
529 tput bold >/dev/null 2>&1 &&
530 tput setaf 1 >/dev/null 2>&1 &&
531 tput sgr0 >/dev/null 2>&1
532 ) &&
533 color=t
534
535 if test -n "$color"
536 then
537 # Save the color control sequences now rather than run tput
538 # each time say_color() is called. This is done for two
539 # reasons:
540 # * TERM will be changed to dumb
541 # * HOME will be changed to a temporary directory and tput
542 # might need to read ~/.terminfo from the original HOME
543 # directory to get the control sequences
544 # Note: This approach assumes the control sequences don't end
545 # in a newline for any terminal of interest (command
546 # substitutions strip trailing newlines). Given that most
547 # (all?) terminals in common use are related to ECMA-48, this
548 # shouldn't be a problem.
549 say_color_error=$(tput bold; tput setaf 1) # bold red
550 say_color_skip=$(tput setaf 4) # blue
551 say_color_warn=$(tput setaf 3) # brown/yellow
552 say_color_pass=$(tput setaf 2) # green
553 say_color_info=$(tput setaf 6) # cyan
554 say_color_reset=$(tput sgr0)
555 say_color_="" # no formatting for normal text
556 say_color () {
557 test -z "$1" && test -n "$quiet" && return
558 eval "say_color_color=\$say_color_$1"
559 shift
560 printf "%s\\n" "$say_color_color$*$say_color_reset"
561 }
562 else
563 say_color() {
564 test -z "$1" && test -n "$quiet" && return
565 shift
566 printf "%s\n" "$*"
567 }
568 fi
569
570 TERM=dumb
571 export TERM
572
573 error () {
574 say_color error "error: $*"
575 finalize_junit_xml
576 GIT_EXIT_OK=t
577 exit 1
578 }
579
580 BUG () {
581 error >&7 "bug in the test script: $*"
582 }
583
584 say () {
585 say_color info "$*"
586 }
587
588 if test -n "$HARNESS_ACTIVE"
589 then
590 if test "$verbose" = t || test -n "$verbose_only"
591 then
592 printf 'Bail out! %s\n' \
593 'verbose mode forbidden under TAP harness; try --verbose-log'
594 exit 1
595 fi
596 fi
597
598 test "${test_description}" != "" ||
599 error "Test script did not set test_description."
600
601 if test "$help" = "t"
602 then
603 printf '%s\n' "$test_description"
604 exit 0
605 fi
606
607 exec 5>&1
608 exec 6<&0
609 exec 7>&2
610 if test "$verbose_log" = "t"
611 then
612 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
613 elif test "$verbose" = "t"
614 then
615 exec 4>&2 3>&1
616 else
617 exec 4>/dev/null 3>/dev/null
618 fi
619
620 # Send any "-x" output directly to stderr to avoid polluting tests
621 # which capture stderr. We can do this unconditionally since it
622 # has no effect if tracing isn't turned on.
623 #
624 # Note that this sets up the trace fd as soon as we assign the variable, so it
625 # must come after the creation of descriptor 4 above. Likewise, we must never
626 # unset this, as it has the side effect of closing descriptor 4, which we
627 # use to show verbose tests to the user.
628 #
629 # Note also that we don't need or want to export it. The tracing is local to
630 # this shell, and we would not want to influence any shells we exec.
631 BASH_XTRACEFD=4
632
633 test_failure=0
634 test_count=0
635 test_fixed=0
636 test_broken=0
637 test_success=0
638
639 test_external_has_tap=0
640
641 die () {
642 code=$?
643 # This is responsible for running the atexit commands even when a
644 # test script run with '--immediate' fails, or when the user hits
645 # ctrl-C, i.e. when 'test_done' is not invoked at all.
646 test_atexit_handler || code=$?
647 if test -n "$GIT_EXIT_OK"
648 then
649 exit $code
650 else
651 echo >&5 "FATAL: Unexpected exit with code $code"
652 exit 1
653 fi
654 }
655
656 GIT_EXIT_OK=
657 trap 'die' EXIT
658 # Disable '-x' tracing, because with some shells, notably dash, it
659 # prevents running the cleanup commands when a test script run with
660 # '--verbose-log -x' is interrupted.
661 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
662
663 # The user-facing functions are loaded from a separate file so that
664 # test_perf subshells can have them too
665 . "$TEST_DIRECTORY/test-lib-functions.sh"
666
667 # You are not expected to call test_ok_ and test_failure_ directly, use
668 # the test_expect_* functions instead.
669
670 test_ok_ () {
671 if test -n "$write_junit_xml"
672 then
673 write_junit_xml_testcase "$*"
674 fi
675 test_success=$(($test_success + 1))
676 say_color "" "ok $test_count - $@"
677 }
678
679 test_failure_ () {
680 if test -n "$write_junit_xml"
681 then
682 junit_insert="<failure message=\"not ok $test_count -"
683 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
684 junit_insert="$junit_insert $(xml_attr_encode \
685 "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
686 then
687 test-tool path-utils skip-n-bytes \
688 "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
689 else
690 printf '%s\n' "$@" | sed 1d
691 fi)")"
692 junit_insert="$junit_insert</failure>"
693 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
694 then
695 junit_insert="$junit_insert<system-err>$(xml_attr_encode \
696 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
697 fi
698 write_junit_xml_testcase "$1" " $junit_insert"
699 fi
700 test_failure=$(($test_failure + 1))
701 say_color error "not ok $test_count - $1"
702 shift
703 printf '%s\n' "$*" | sed -e 's/^/# /'
704 test "$immediate" = "" || { finalize_junit_xml; GIT_EXIT_OK=t; exit 1; }
705 }
706
707 test_known_broken_ok_ () {
708 if test -n "$write_junit_xml"
709 then
710 write_junit_xml_testcase "$* (breakage fixed)"
711 fi
712 test_fixed=$(($test_fixed+1))
713 say_color error "ok $test_count - $@ # TODO known breakage vanished"
714 }
715
716 test_known_broken_failure_ () {
717 if test -n "$write_junit_xml"
718 then
719 write_junit_xml_testcase "$* (known breakage)"
720 fi
721 test_broken=$(($test_broken+1))
722 say_color warn "not ok $test_count - $@ # TODO known breakage"
723 }
724
725 test_debug () {
726 test "$debug" = "" || eval "$1"
727 }
728
729 match_pattern_list () {
730 arg="$1"
731 shift
732 test -z "$*" && return 1
733 for pattern_
734 do
735 case "$arg" in
736 $pattern_)
737 return 0
738 esac
739 done
740 return 1
741 }
742
743 match_test_selector_list () {
744 title="$1"
745 shift
746 arg="$1"
747 shift
748 test -z "$1" && return 0
749
750 # Both commas and whitespace are accepted as separators.
751 OLDIFS=$IFS
752 IFS=' ,'
753 set -- $1
754 IFS=$OLDIFS
755
756 # If the first selector is negative we include by default.
757 include=
758 case "$1" in
759 !*) include=t ;;
760 esac
761
762 for selector
763 do
764 orig_selector=$selector
765
766 positive=t
767 case "$selector" in
768 !*)
769 positive=
770 selector=${selector##?}
771 ;;
772 esac
773
774 test -z "$selector" && continue
775
776 case "$selector" in
777 *-*)
778 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
779 then
780 echo "error: $title: invalid non-numeric in range" \
781 "start: '$orig_selector'" >&2
782 exit 1
783 fi
784 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
785 then
786 echo "error: $title: invalid non-numeric in range" \
787 "end: '$orig_selector'" >&2
788 exit 1
789 fi
790 ;;
791 *)
792 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
793 then
794 echo "error: $title: invalid non-numeric in test" \
795 "selector: '$orig_selector'" >&2
796 exit 1
797 fi
798 esac
799
800 # Short cut for "obvious" cases
801 test -z "$include" && test -z "$positive" && continue
802 test -n "$include" && test -n "$positive" && continue
803
804 case "$selector" in
805 -*)
806 if test $arg -le ${selector#-}
807 then
808 include=$positive
809 fi
810 ;;
811 *-)
812 if test $arg -ge ${selector%-}
813 then
814 include=$positive
815 fi
816 ;;
817 *-*)
818 if test ${selector%%-*} -le $arg \
819 && test $arg -le ${selector#*-}
820 then
821 include=$positive
822 fi
823 ;;
824 *)
825 if test $arg -eq $selector
826 then
827 include=$positive
828 fi
829 ;;
830 esac
831 done
832
833 test -n "$include"
834 }
835
836 maybe_teardown_verbose () {
837 test -z "$verbose_only" && return
838 exec 4>/dev/null 3>/dev/null
839 verbose=
840 }
841
842 last_verbose=t
843 maybe_setup_verbose () {
844 test -z "$verbose_only" && return
845 if match_pattern_list $test_count $verbose_only
846 then
847 exec 4>&2 3>&1
848 # Emit a delimiting blank line when going from
849 # non-verbose to verbose. Within verbose mode the
850 # delimiter is printed by test_expect_*. The choice
851 # of the initial $last_verbose is such that before
852 # test 1, we do not print it.
853 test -z "$last_verbose" && echo >&3 ""
854 verbose=t
855 else
856 exec 4>/dev/null 3>/dev/null
857 verbose=
858 fi
859 last_verbose=$verbose
860 }
861
862 maybe_teardown_valgrind () {
863 test -z "$GIT_VALGRIND" && return
864 GIT_VALGRIND_ENABLED=
865 }
866
867 maybe_setup_valgrind () {
868 test -z "$GIT_VALGRIND" && return
869 if test -z "$valgrind_only"
870 then
871 GIT_VALGRIND_ENABLED=t
872 return
873 fi
874 GIT_VALGRIND_ENABLED=
875 if match_pattern_list $test_count $valgrind_only
876 then
877 GIT_VALGRIND_ENABLED=t
878 fi
879 }
880
881 want_trace () {
882 test "$trace" = t && {
883 test "$verbose" = t || test "$verbose_log" = t
884 }
885 }
886
887 # This is a separate function because some tests use
888 # "return" to end a test_expect_success block early
889 # (and we want to make sure we run any cleanup like
890 # "set +x").
891 test_eval_inner_ () {
892 # Do not add anything extra (including LF) after '$*'
893 eval "
894 want_trace && set -x
895 $*"
896 }
897
898 test_eval_ () {
899 # If "-x" tracing is in effect, then we want to avoid polluting stderr
900 # with non-test commands. But once in "set -x" mode, we cannot prevent
901 # the shell from printing the "set +x" to turn it off (nor the saving
902 # of $? before that). But we can make sure that the output goes to
903 # /dev/null.
904 #
905 # There are a few subtleties here:
906 #
907 # - we have to redirect descriptor 4 in addition to 2, to cover
908 # BASH_XTRACEFD
909 #
910 # - the actual eval has to come before the redirection block (since
911 # it needs to see descriptor 4 to set up its stderr)
912 #
913 # - likewise, any error message we print must be outside the block to
914 # access descriptor 4
915 #
916 # - checking $? has to come immediately after the eval, but it must
917 # be _inside_ the block to avoid polluting the "set -x" output
918 #
919
920 test_eval_inner_ "$@" </dev/null >&3 2>&4
921 {
922 test_eval_ret_=$?
923 if want_trace
924 then
925 set +x
926 fi
927 } 2>/dev/null 4>&2
928
929 if test "$test_eval_ret_" != 0 && want_trace
930 then
931 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
932 fi
933 return $test_eval_ret_
934 }
935
936 test_run_ () {
937 test_cleanup=:
938 expecting_failure=$2
939
940 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
941 # turn off tracing for this test-eval, as it simply creates
942 # confusing noise in the "-x" output
943 trace_tmp=$trace
944 trace=
945 # 117 is magic because it is unlikely to match the exit
946 # code of other programs
947 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
948 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
949 then
950 BUG "broken &&-chain or run-away HERE-DOC: $1"
951 fi
952 trace=$trace_tmp
953 fi
954
955 setup_malloc_check
956 test_eval_ "$1"
957 eval_ret=$?
958 teardown_malloc_check
959
960 if test -z "$immediate" || test $eval_ret = 0 ||
961 test -n "$expecting_failure" && test "$test_cleanup" != ":"
962 then
963 setup_malloc_check
964 test_eval_ "$test_cleanup"
965 teardown_malloc_check
966 fi
967 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
968 then
969 echo ""
970 fi
971 return "$eval_ret"
972 }
973
974 test_start_ () {
975 test_count=$(($test_count+1))
976 maybe_setup_verbose
977 maybe_setup_valgrind
978 if test -n "$write_junit_xml"
979 then
980 junit_start=$(test-tool date getnanos)
981 fi
982 }
983
984 test_finish_ () {
985 echo >&3 ""
986 maybe_teardown_valgrind
987 maybe_teardown_verbose
988 if test -n "$GIT_TEST_TEE_OFFSET"
989 then
990 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
991 "$GIT_TEST_TEE_OUTPUT_FILE")
992 fi
993 }
994
995 test_skip () {
996 to_skip=
997 skipped_reason=
998 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
999 then
1000 to_skip=t
1001 skipped_reason="GIT_SKIP_TESTS"
1002 fi
1003 if test -z "$to_skip" && test -n "$test_prereq" &&
1004 ! test_have_prereq "$test_prereq"
1005 then
1006 to_skip=t
1007
1008 of_prereq=
1009 if test "$missing_prereq" != "$test_prereq"
1010 then
1011 of_prereq=" of $test_prereq"
1012 fi
1013 skipped_reason="missing $missing_prereq${of_prereq}"
1014 fi
1015 if test -z "$to_skip" && test -n "$run_list" &&
1016 ! match_test_selector_list '--run' $test_count "$run_list"
1017 then
1018 to_skip=t
1019 skipped_reason="--run"
1020 fi
1021
1022 case "$to_skip" in
1023 t)
1024 if test -n "$write_junit_xml"
1025 then
1026 message="$(xml_attr_encode "$skipped_reason")"
1027 write_junit_xml_testcase "$1" \
1028 " <skipped message=\"$message\" />"
1029 fi
1030
1031 say_color skip >&3 "skipping test: $@"
1032 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1033 : true
1034 ;;
1035 *)
1036 false
1037 ;;
1038 esac
1039 }
1040
1041 # stub; perf-lib overrides it
1042 test_at_end_hook_ () {
1043 :
1044 }
1045
1046 write_junit_xml () {
1047 case "$1" in
1048 --truncate)
1049 >"$junit_xml_path"
1050 junit_have_testcase=
1051 shift
1052 ;;
1053 esac
1054 printf '%s\n' "$@" >>"$junit_xml_path"
1055 }
1056
1057 xml_attr_encode () {
1058 printf '%s\n' "$@" | test-tool xml-encode
1059 }
1060
1061 write_junit_xml_testcase () {
1062 junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1063 shift
1064 junit_attrs="$junit_attrs classname=\"$this_test\""
1065 junit_attrs="$junit_attrs time=\"$(test-tool \
1066 date getnanos $junit_start)\""
1067 write_junit_xml "$(printf '%s\n' \
1068 " <testcase $junit_attrs>" "$@" " </testcase>")"
1069 junit_have_testcase=t
1070 }
1071
1072 finalize_junit_xml () {
1073 if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1074 then
1075 test -n "$junit_have_testcase" || {
1076 junit_start=$(test-tool date getnanos)
1077 write_junit_xml_testcase "all tests skipped"
1078 }
1079
1080 # adjust the overall time
1081 junit_time=$(test-tool date getnanos $junit_suite_start)
1082 sed "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1083 <"$junit_xml_path" >"$junit_xml_path.new"
1084 mv "$junit_xml_path.new" "$junit_xml_path"
1085
1086 write_junit_xml " </testsuite>" "</testsuites>"
1087 write_junit_xml=
1088 fi
1089 }
1090
1091 test_atexit_cleanup=:
1092 test_atexit_handler () {
1093 # In a succeeding test script 'test_atexit_handler' is invoked
1094 # twice: first from 'test_done', then from 'die' in the trap on
1095 # EXIT.
1096 # This condition and resetting 'test_atexit_cleanup' below makes
1097 # sure that the registered cleanup commands are run only once.
1098 test : != "$test_atexit_cleanup" || return 0
1099
1100 setup_malloc_check
1101 test_eval_ "$test_atexit_cleanup"
1102 test_atexit_cleanup=:
1103 teardown_malloc_check
1104 }
1105
1106 test_done () {
1107 GIT_EXIT_OK=t
1108
1109 # Run the atexit commands _before_ the trash directory is
1110 # removed, so the commands can access pidfiles and socket files.
1111 test_atexit_handler
1112
1113 finalize_junit_xml
1114
1115 if test -z "$HARNESS_ACTIVE"
1116 then
1117 mkdir -p "$TEST_RESULTS_DIR"
1118
1119 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1120 total $test_count
1121 success $test_success
1122 fixed $test_fixed
1123 broken $test_broken
1124 failed $test_failure
1125
1126 EOF
1127 fi
1128
1129 if test "$test_fixed" != 0
1130 then
1131 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1132 fi
1133 if test "$test_broken" != 0
1134 then
1135 say_color warn "# still have $test_broken known breakage(s)"
1136 fi
1137 if test "$test_broken" != 0 || test "$test_fixed" != 0
1138 then
1139 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1140 msg="remaining $test_remaining test(s)"
1141 else
1142 test_remaining=$test_count
1143 msg="$test_count test(s)"
1144 fi
1145 case "$test_failure" in
1146 0)
1147 if test $test_external_has_tap -eq 0
1148 then
1149 if test $test_remaining -gt 0
1150 then
1151 say_color pass "# passed all $msg"
1152 fi
1153
1154 # Maybe print SKIP message
1155 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1156 case "$test_count" in
1157 0)
1158 say "1..$test_count${skip_all:+ $skip_all}"
1159 ;;
1160 *)
1161 test -z "$skip_all" ||
1162 say_color warn "$skip_all"
1163 say "1..$test_count"
1164 ;;
1165 esac
1166 fi
1167
1168 if test -z "$debug"
1169 then
1170 test -d "$TRASH_DIRECTORY" ||
1171 error "Tests passed but trash directory already removed before test cleanup; aborting"
1172
1173 cd "$TRASH_DIRECTORY/.." &&
1174 rm -fr "$TRASH_DIRECTORY" || {
1175 # try again in a bit
1176 sleep 5;
1177 rm -fr "$TRASH_DIRECTORY"
1178 } ||
1179 error "Tests passed but test cleanup failed; aborting"
1180 fi
1181 test_at_end_hook_
1182
1183 exit 0 ;;
1184
1185 *)
1186 if test $test_external_has_tap -eq 0
1187 then
1188 say_color error "# failed $test_failure among $msg"
1189 say "1..$test_count"
1190 fi
1191
1192 exit 1 ;;
1193
1194 esac
1195 }
1196
1197 if test -n "$valgrind"
1198 then
1199 make_symlink () {
1200 test -h "$2" &&
1201 test "$1" = "$(readlink "$2")" || {
1202 # be super paranoid
1203 if mkdir "$2".lock
1204 then
1205 rm -f "$2" &&
1206 ln -s "$1" "$2" &&
1207 rm -r "$2".lock
1208 else
1209 while test -d "$2".lock
1210 do
1211 say "Waiting for lock on $2."
1212 sleep 1
1213 done
1214 fi
1215 }
1216 }
1217
1218 make_valgrind_symlink () {
1219 # handle only executables, unless they are shell libraries that
1220 # need to be in the exec-path.
1221 test -x "$1" ||
1222 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1223 return;
1224
1225 base=$(basename "$1")
1226 case "$base" in
1227 test-*)
1228 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1229 ;;
1230 *)
1231 symlink_target="$GIT_BUILD_DIR/$base"
1232 ;;
1233 esac
1234 # do not override scripts
1235 if test -x "$symlink_target" &&
1236 test ! -d "$symlink_target" &&
1237 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1238 then
1239 symlink_target=../valgrind.sh
1240 fi
1241 case "$base" in
1242 *.sh|*.perl)
1243 symlink_target=../unprocessed-script
1244 esac
1245 # create the link, or replace it if it is out of date
1246 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1247 }
1248
1249 # override all git executables in TEST_DIRECTORY/..
1250 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1251 mkdir -p "$GIT_VALGRIND"/bin
1252 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1253 do
1254 make_valgrind_symlink $file
1255 done
1256 # special-case the mergetools loadables
1257 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1258 OLDIFS=$IFS
1259 IFS=:
1260 for path in $PATH
1261 do
1262 ls "$path"/git-* 2> /dev/null |
1263 while read file
1264 do
1265 make_valgrind_symlink "$file"
1266 done
1267 done
1268 IFS=$OLDIFS
1269 PATH=$GIT_VALGRIND/bin:$PATH
1270 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1271 export GIT_VALGRIND
1272 GIT_VALGRIND_MODE="$valgrind"
1273 export GIT_VALGRIND_MODE
1274 GIT_VALGRIND_ENABLED=t
1275 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1276 export GIT_VALGRIND_ENABLED
1277 elif test -n "$GIT_TEST_INSTALLED"
1278 then
1279 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1280 error "Cannot run git from $GIT_TEST_INSTALLED."
1281 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1282 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1283 else # normal case, use ../bin-wrappers only unless $with_dashes:
1284 if test -n "$no_bin_wrappers"
1285 then
1286 with_dashes=t
1287 else
1288 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1289 if ! test -x "$git_bin_dir/git"
1290 then
1291 if test -z "$with_dashes"
1292 then
1293 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1294 fi
1295 with_dashes=t
1296 fi
1297 PATH="$git_bin_dir:$PATH"
1298 fi
1299 GIT_EXEC_PATH=$GIT_BUILD_DIR
1300 if test -n "$with_dashes"
1301 then
1302 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1303 fi
1304 fi
1305 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1306 GIT_CONFIG_NOSYSTEM=1
1307 GIT_ATTR_NOSYSTEM=1
1308 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1309
1310 if test -z "$GIT_TEST_CMP"
1311 then
1312 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1313 then
1314 GIT_TEST_CMP="$DIFF -c"
1315 else
1316 GIT_TEST_CMP="$DIFF -u"
1317 fi
1318 fi
1319
1320 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1321 export GITPERLLIB
1322 test -d "$GIT_BUILD_DIR"/templates/blt || {
1323 error "You haven't built things yet, have you?"
1324 }
1325
1326 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1327 then
1328 echo >&2 'You need to build test-tool:'
1329 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1330 exit 1
1331 fi
1332
1333 # Test repository
1334 rm -fr "$TRASH_DIRECTORY" || {
1335 GIT_EXIT_OK=t
1336 echo >&5 "FATAL: Cannot prepare test area"
1337 exit 1
1338 }
1339
1340 HOME="$TRASH_DIRECTORY"
1341 GNUPGHOME="$HOME/gnupg-home-not-used"
1342 export HOME GNUPGHOME
1343
1344 if test -z "$TEST_NO_CREATE_REPO"
1345 then
1346 test_create_repo "$TRASH_DIRECTORY"
1347 else
1348 mkdir -p "$TRASH_DIRECTORY"
1349 fi
1350
1351 # Use -P to resolve symlinks in our working directory so that the cwd
1352 # in subprocesses like git equals our $PWD (for pathname comparisons).
1353 cd -P "$TRASH_DIRECTORY" || exit 1
1354
1355 this_test=${0##*/}
1356 this_test=${this_test%%-*}
1357 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1358 then
1359 say_color info >&3 "skipping test $this_test altogether"
1360 skip_all="skip all tests in $this_test"
1361 test_done
1362 fi
1363
1364 if test -n "$write_junit_xml"
1365 then
1366 junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1367 mkdir -p "$junit_xml_dir"
1368 junit_xml_base=${0##*/}
1369 junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1370 junit_attrs="name=\"${junit_xml_base%.sh}\""
1371 junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1372 date +%Y-%m-%dT%H:%M:%S)\""
1373 write_junit_xml --truncate "<testsuites>" " <testsuite $junit_attrs>"
1374 junit_suite_start=$(test-tool date getnanos)
1375 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1376 then
1377 GIT_TEST_TEE_OFFSET=0
1378 fi
1379 fi
1380
1381 # Provide an implementation of the 'yes' utility; the upper bound
1382 # limit is there to help Windows that cannot stop this loop from
1383 # wasting cycles when the downstream stops reading, so do not be
1384 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1385 # limit the output of the yes utility", 2016-02-02)
1386 yes () {
1387 if test $# = 0
1388 then
1389 y=y
1390 else
1391 y="$*"
1392 fi
1393
1394 i=0
1395 while test $i -lt 99
1396 do
1397 echo "$y"
1398 i=$(($i+1))
1399 done
1400 }
1401
1402 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1403 # thus needs to be set up really early, and set an internal variable
1404 # for convenience so the hot test_set_prereq() codepath doesn't need
1405 # to call "git env--helper". Only do that work if needed by seeing if
1406 # GIT_TEST_FAIL_PREREQS is set at all.
1407 GIT_TEST_FAIL_PREREQS_INTERNAL=
1408 if test -n "$GIT_TEST_FAIL_PREREQS"
1409 then
1410 if git env--helper --type=bool --default=0 --exit-code GIT_TEST_FAIL_PREREQS
1411 then
1412 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1413 test_set_prereq FAIL_PREREQS
1414 fi
1415 else
1416 test_lazy_prereq FAIL_PREREQS '
1417 git env--helper --type=bool --default=0 --exit-code GIT_TEST_FAIL_PREREQS
1418 '
1419 fi
1420
1421 # Fix some commands on Windows
1422 uname_s=$(uname -s)
1423 case $uname_s in
1424 *MINGW*)
1425 # Windows has its own (incompatible) sort and find
1426 sort () {
1427 /usr/bin/sort "$@"
1428 }
1429 find () {
1430 /usr/bin/find "$@"
1431 }
1432 # git sees Windows-style pwd
1433 pwd () {
1434 builtin pwd -W
1435 }
1436 # no POSIX permissions
1437 # backslashes in pathspec are converted to '/'
1438 # exec does not inherit the PID
1439 test_set_prereq MINGW
1440 test_set_prereq NATIVE_CRLF
1441 test_set_prereq SED_STRIPS_CR
1442 test_set_prereq GREP_STRIPS_CR
1443 GIT_TEST_CMP=mingw_test_cmp
1444 ;;
1445 *CYGWIN*)
1446 test_set_prereq POSIXPERM
1447 test_set_prereq EXECKEEPSPID
1448 test_set_prereq CYGWIN
1449 test_set_prereq SED_STRIPS_CR
1450 test_set_prereq GREP_STRIPS_CR
1451 ;;
1452 *)
1453 test_set_prereq POSIXPERM
1454 test_set_prereq BSLASHPSPEC
1455 test_set_prereq EXECKEEPSPID
1456 ;;
1457 esac
1458
1459 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1460 test -z "$NO_PERL" && test_set_prereq PERL
1461 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1462 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1463 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1464 test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1465 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1466 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1467
1468 if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1469 then
1470 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1471 export GIT_TEST_GETTEXT_POISON
1472 unset GIT_TEST_GETTEXT_POISON_ORIG
1473 fi
1474
1475 test_lazy_prereq C_LOCALE_OUTPUT '
1476 ! git env--helper --type=bool --default=0 --exit-code GIT_TEST_GETTEXT_POISON
1477 '
1478
1479 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1480 then
1481 GIT_TEST_CHECK_CACHE_TREE=true
1482 export GIT_TEST_CHECK_CACHE_TREE
1483 fi
1484
1485 test_lazy_prereq PIPE '
1486 # test whether the filesystem supports FIFOs
1487 test_have_prereq !MINGW,!CYGWIN &&
1488 rm -f testfifo && mkfifo testfifo
1489 '
1490
1491 test_lazy_prereq SYMLINKS '
1492 # test whether the filesystem supports symbolic links
1493 ln -s x y && test -h y
1494 '
1495
1496 test_lazy_prereq FILEMODE '
1497 test "$(git config --bool core.filemode)" = true
1498 '
1499
1500 test_lazy_prereq CASE_INSENSITIVE_FS '
1501 echo good >CamelCase &&
1502 echo bad >camelcase &&
1503 test "$(cat CamelCase)" != good
1504 '
1505
1506 test_lazy_prereq FUNNYNAMES '
1507 test_have_prereq !MINGW &&
1508 touch -- \
1509 "FUNNYNAMES tab embedded" \
1510 "FUNNYNAMES \"quote embedded\"" \
1511 "FUNNYNAMES newline
1512 embedded" 2>/dev/null &&
1513 rm -- \
1514 "FUNNYNAMES tab embedded" \
1515 "FUNNYNAMES \"quote embedded\"" \
1516 "FUNNYNAMES newline
1517 embedded" 2>/dev/null
1518 '
1519
1520 test_lazy_prereq UTF8_NFD_TO_NFC '
1521 # check whether FS converts nfd unicode to nfc
1522 auml=$(printf "\303\244")
1523 aumlcdiar=$(printf "\141\314\210")
1524 >"$auml" &&
1525 test -f "$aumlcdiar"
1526 '
1527
1528 test_lazy_prereq AUTOIDENT '
1529 sane_unset GIT_AUTHOR_NAME &&
1530 sane_unset GIT_AUTHOR_EMAIL &&
1531 git var GIT_AUTHOR_IDENT
1532 '
1533
1534 test_lazy_prereq EXPENSIVE '
1535 test -n "$GIT_TEST_LONG"
1536 '
1537
1538 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1539 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1540 '
1541
1542 test_lazy_prereq USR_BIN_TIME '
1543 test -x /usr/bin/time
1544 '
1545
1546 test_lazy_prereq NOT_ROOT '
1547 uid=$(id -u) &&
1548 test "$uid" != 0
1549 '
1550
1551 test_lazy_prereq JGIT '
1552 jgit --version
1553 '
1554
1555 # SANITY is about "can you correctly predict what the filesystem would
1556 # do by only looking at the permission bits of the files and
1557 # directories?" A typical example of !SANITY is running the test
1558 # suite as root, where a test may expect "chmod -r file && cat file"
1559 # to fail because file is supposed to be unreadable after a successful
1560 # chmod. In an environment (i.e. combination of what filesystem is
1561 # being used and who is running the tests) that lacks SANITY, you may
1562 # be able to delete or create a file when the containing directory
1563 # doesn't have write permissions, or access a file even if the
1564 # containing directory doesn't have read or execute permissions.
1565
1566 test_lazy_prereq SANITY '
1567 mkdir SANETESTD.1 SANETESTD.2 &&
1568
1569 chmod +w SANETESTD.1 SANETESTD.2 &&
1570 >SANETESTD.1/x 2>SANETESTD.2/x &&
1571 chmod -w SANETESTD.1 &&
1572 chmod -r SANETESTD.1/x &&
1573 chmod -rx SANETESTD.2 ||
1574 BUG "cannot prepare SANETESTD"
1575
1576 ! test -r SANETESTD.1/x &&
1577 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1578 status=$?
1579
1580 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1581 rm -rf SANETESTD.1 SANETESTD.2 ||
1582 BUG "cannot clean SANETESTD"
1583 return $status
1584 '
1585
1586 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1587 GIT_UNZIP=${GIT_UNZIP:-unzip}
1588 test_lazy_prereq UNZIP '
1589 "$GIT_UNZIP" -v
1590 test $? -ne 127
1591 '
1592
1593 run_with_limited_cmdline () {
1594 (ulimit -s 128 && "$@")
1595 }
1596
1597 test_lazy_prereq CMDLINE_LIMIT '
1598 test_have_prereq !MINGW,!CYGWIN &&
1599 run_with_limited_cmdline true
1600 '
1601
1602 run_with_limited_stack () {
1603 (ulimit -s 128 && "$@")
1604 }
1605
1606 test_lazy_prereq ULIMIT_STACK_SIZE '
1607 test_have_prereq !MINGW,!CYGWIN &&
1608 run_with_limited_stack true
1609 '
1610
1611 build_option () {
1612 git version --build-options |
1613 sed -ne "s/^$1: //p"
1614 }
1615
1616 test_lazy_prereq LONG_IS_64BIT '
1617 test 8 -le "$(build_option sizeof-long)"
1618 '
1619
1620 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1621 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1622
1623 test_lazy_prereq CURL '
1624 curl --version
1625 '
1626
1627 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1628 # which will not work with other hash algorithms and tests that work but don't
1629 # test anything meaningful (e.g. special values which cause short collisions).
1630 test_lazy_prereq SHA1 '
1631 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1632 '
1633
1634 test_lazy_prereq REBASE_P '
1635 test -z "$GIT_TEST_SKIP_REBASE_P"
1636 '